function [output_args] = zebra_batch_workings_r1(zebra_route_path, current_batch_dir, image_base_name, image_names2, computer_ID)
%This function organises the batch processing
output_args = 1;
verbose_cell_by_cell = 0;

base_path = [zebra_route_path, current_batch_dir];

prompt = sprintf('Process: "%s/%s"?: (1/0)): ', current_batch_dir, image_base_name);    
result = input(prompt);
if result == 1;
    prompt = sprintf('Reanalyse/analyse some images in: "%s/%s"?: (1/0)): ', current_batch_dir, image_base_name);
    result2 = input(prompt);
    if(result2 == 1);
        reanalyse = 1;
    elseif(result2 == 2);
        reanalyse = 1;
        verbose_cell_by_cell = 1;           
    else
        reanalyse = 0;
    end;
    outer_cells_all_stats_ALL_N = [];
    whole_heart_stats_ALL_N = [];
    for n=1:size(image_names2, 2);
        if reanalyse == 0;
            proc = 0;
        else
            proc = 1;
        end;

            image_path = [image_base_name, char(image_names2(:,n)), '\'];
            image_path_file = [zebra_route_path, current_batch_dir, image_base_name, char(image_names2(:,n)), '\'];
        outer_cells_all_stats_file = [zebra_route_path, current_batch_dir, image_base_name, char(image_names2(:,n)), '\', 'ZEBRA_this_heart_outer_cells_all_stats.csv'];
        whole_heart_stats_file = [zebra_route_path, current_batch_dir, image_base_name, char(image_names2(:,n)), '\', 'ZEBRA_this_heart_whole_heart_all_stats.csv'];
        if (exist(outer_cells_all_stats_file, 'file') == 2) && (exist(whole_heart_stats_file, 'file') == 2) && reanalyse == 1
            prompt = sprintf('reprocess %s? (1/0)): ', [image_base_name, char(image_names2(:,n))]);
            result = input(prompt);
            if result == 1;
                proc = 1;
            else
                proc = 0;
            end;
        end;
        if proc == 1;
            accept = 0;
            while accept == 0
                fprintf('Processing %s? : ', [image_base_name, char(image_names2(:,n))]);
                prompt = sprintf('Standard mode (1) or verbose (2) (1/2)): ');
                result3 = input(prompt);
                if(result3 == 2);
                        verbose_cell_by_cell = 1;  
                else
                        verbose_cell_by_cell = 0;
                end;
                [outer_cells_all_stats, whole_heart_stats] =  zebra_angle_r1(base_path, image_path, verbose_cell_by_cell, computer_ID);
                prompt = sprintf('Accept(1) or redo(0)?: (1/0)): ');
                accept = input(prompt);
            end;
            
            csvwrite(strcat(image_path_file, 'ZEBRA_this_heart_outer_cells_all_stats.csv'), outer_cells_all_stats);
            header_fileID = fopen(strcat(image_path_file, 'ZEBRA_this_heart_outer_cells_all_stats_HEADER.csv'),'w');
            fprintf(header_fileID, 'my#,PA_Cell_ID,Centroid_X,Centroid_Y,Perimeter_X,Perimeter_Y,Perimeter_Index,Perimeter_order,tensor_file_1,tensor_file_2,tensor_file_3,tensor_file_4,Unused,Alpha,Sector,Gamma,Area (direct) - pixels,Area (direct)- um sq,Area (indirect) - pixels, Area (indirect)- sq um');
            fclose(header_fileID);

            csvwrite(strcat(image_path_file, 'ZEBRA_this_heart_whole_heart_all_stats.csv'), whole_heart_stats);
            header_fileID = fopen(strcat(image_path_file, 'ZEBRA_this_heart_whole_heart_all_stats_HEADER.csv'),'w');
            fprintf(header_fileID, 'Cardiac Axis (0-360), Corrected Area (square micrometers), Clockwise image (=1)');
            fclose(header_fileID);
           
            outer_cells_all_stats_ALL_N = cat(1,outer_cells_all_stats_ALL_N, outer_cells_all_stats);
            whole_heart_stats_ALL_N = cat(1,whole_heart_stats_ALL_N, whole_heart_stats);
        else
            outer_cells_all_stats = csvread(strcat(image_path_file, 'ZEBRA_this_heart_outer_cells_all_stats.csv'));
            whole_heart_stats = csvread(strcat(image_path_file, 'ZEBRA_this_heart_whole_heart_all_stats.csv'));
            outer_cells_all_stats_ALL_N = cat(1,outer_cells_all_stats_ALL_N, outer_cells_all_stats);
            whole_heart_stats_ALL_N = cat(1,whole_heart_stats_ALL_N, whole_heart_stats); 
        end;
    end;

     prompt = sprintf('Collate, calculate mean and save collated data?: (1/0)): ');
     result = input(prompt);
     if result == 1;
            %SORT whole_heart_stats_ALL_N
            %     S_lc            %SECTOR 1
            %     S_o             %SECTOR 2
            %     S_gc_A          %SECTOR 3
            %     S_gc_B          %SECTOR 4
            %     S_gc_C          %SECTOR 5
            %     S_av            %SECTOR 6
            sector_names = {'Lesser Curvature','Outflow','Greater Curvature (near outflow)','Greater Curvature (mid)','Greater Curvature (near AV-J)','AV-J'};

            outer_cells_all_stats_ALL_N_sector_ALL_collated_w_NaN = [];
            for n=1:6;
                [~, index15] = sort(outer_cells_all_stats_ALL_N(:,15));
                outer_cells_all_stats_ALL_N_sort_sector = outer_cells_all_stats_ALL_N(index15,:);
                indices = find(outer_cells_all_stats_ALL_N_sort_sector(:,15) == n); %S_lc
                outer_cells_all_stats_ALL_N_sector_n = outer_cells_all_stats_ALL_N_sort_sector(indices,:);
                outer_cells_all_stats_ALL_N_sector_n_alpha_deg_w_NaN = outer_cells_all_stats_ALL_N_sector_n(:,14);
                total_cells = size(outer_cells_all_stats_ALL_N_sector_n_alpha_deg_w_NaN,1);
                fprintf('Total cells: %d\n', total_cells);

                outer_cells_all_stats_ALL_N_sector_n_gamma_w_NaN = outer_cells_all_stats_ALL_N_sector_n(:,16);
                outer_cells_all_stats_ALL_N_sector_n_area_w_NaN = outer_cells_all_stats_ALL_N_sector_n(:,18); %17 is also an area estimate, but from c hull

                indices = find(isnan(outer_cells_all_stats_ALL_N_sector_n_alpha_deg_w_NaN(:,:)) == 0);
                outer_cells_all_stats_ALL_N_sector_n_alpha_deg = outer_cells_all_stats_ALL_N_sector_n_alpha_deg_w_NaN(indices);
                wNaN_cells = size(outer_cells_all_stats_ALL_N_sector_n_alpha_deg,1);
                fprintf('Without NaN cells: %d\n', wNaN_cells);
                fprintf('NaN cells: %d\n', total_cells-wNaN_cells);

                outer_cells_all_stats_ALL_N_sector_n_gamma = outer_cells_all_stats_ALL_N_sector_n_gamma_w_NaN(indices);
                outer_cells_all_stats_ALL_N_sector_n_area = outer_cells_all_stats_ALL_N_sector_n_area_w_NaN(indices);
                outer_cells_all_stats_ALL_N_sector_ALL_alpha_deg(1:size(outer_cells_all_stats_ALL_N_sector_n_alpha_deg),n) = outer_cells_all_stats_ALL_N_sector_n_alpha_deg;
                outer_cells_all_stats_ALL_N_sector_ALL_gamma(1:size(outer_cells_all_stats_ALL_N_sector_n_gamma),n) = outer_cells_all_stats_ALL_N_sector_n_gamma;
                outer_cells_all_stats_ALL_N_sector_ALL_area(1:size(outer_cells_all_stats_ALL_N_sector_n_area),n) = outer_cells_all_stats_ALL_N_sector_n_area;

                outer_cells_all_stats_ALL_N_sector_n_alpha_rad = circ_ang2rad(outer_cells_all_stats_ALL_N_sector_n_alpha_deg);
                outer_cells_all_stats_ALL_N_sector_1_mean_deg=(circ_rad2ang(circ_mean((2*outer_cells_all_stats_ALL_N_sector_n_alpha_rad))))/2;
                fprintf('Sector %d: mean to normal is: %f\n', n, outer_cells_all_stats_ALL_N_sector_1_mean_deg);
                zebra_circ_plot_r1(outer_cells_all_stats_ALL_N_sector_n_alpha_rad,'hist',[],36,true,false,'linewidth',2,'color','r');
                sector = sprintf('%s(%d), Mean: %3.2f\n', char(sector_names(n)), n, outer_cells_all_stats_ALL_N_sector_1_mean_deg);
                
                fig = gcf;
                txt = title(sector, 'Color', 'blue', 'FontSize', 18);
                fig_print_path = [base_path, 'ZEBRA_all_sectors_alpha_deg_ROSE_SECTOR_', char(sector_names(n))];
                print('-dpdf', fig_print_path);
                saveas(fig, [fig_print_path, '.png']);
                outer_cells_all_stats_ALL_N_sector_1_mean_gamma = mean(outer_cells_all_stats_ALL_N_sector_n_gamma);
                outer_cells_all_stats_ALL_N_sector_1_std_gamma = std(outer_cells_all_stats_ALL_N_sector_n_gamma);
                fprintf('Sector %d: mean gamma is: %f+/-%f (ratio)\n', n, outer_cells_all_stats_ALL_N_sector_1_mean_gamma, outer_cells_all_stats_ALL_N_sector_1_std_gamma);
                
                outer_cells_all_stats_ALL_N_sector_1_mean_area = mean(outer_cells_all_stats_ALL_N_sector_n_area);
                outer_cells_all_stats_ALL_N_sector_1_std_area = std(outer_cells_all_stats_ALL_N_sector_n_area);
                fprintf('Sector %d: mean area is: %f+/-%f pixels\n', n, outer_cells_all_stats_ALL_N_sector_1_mean_area, outer_cells_all_stats_ALL_N_sector_1_std_area);
               
                
                outer_cells_all_stats_ALL_N_sector_n_all_w_NaN = outer_cells_all_stats_ALL_N_sector_n(:,:);
                outer_cells_all_stats_ALL_N_sector_ALL_collated_w_NaN = cat(1, outer_cells_all_stats_ALL_N_sector_ALL_collated_w_NaN, outer_cells_all_stats_ALL_N_sector_n_all_w_NaN);  
                
                ginput(1);
                close(fig);
            end;
            
            csvwrite(strcat(base_path, 'ZEBRA_all_sectors_alpha_deg.csv'), outer_cells_all_stats_ALL_N_sector_ALL_alpha_deg); 
            header_fileID = fopen(strcat(base_path, 'ZEBRA_all_sectors_alpha_deg_HEADER.csv'),'w');
            fprintf(header_fileID, 'Sector 1, Sector 2, Sector 3 , Sector 4, Sector 5, Sector 6');
            fclose(header_fileID);

            csvwrite(strcat(base_path, 'ZEBRA_all_sectors_gamma.csv'), outer_cells_all_stats_ALL_N_sector_ALL_gamma);
            header_fileID = fopen(strcat(base_path, 'ZEBRA_all_sectors_gamma_HEADER.csv'),'w');
            fprintf(header_fileID, 'Sector 1, Sector 2, Sector 3 , Sector 4, Sector 5, Sector 6');
            fclose(header_fileID);
            
            csvwrite(strcat(base_path, 'ZEBRA_all_sectors_area.csv'), outer_cells_all_stats_ALL_N_sector_ALL_area);
            header_fileID = fopen(strcat(base_path, 'ZEBRA_all_sectors_area_HEADER.csv'),'w');
            fprintf(header_fileID, 'Sector 1, Sector 2, Sector 3 , Sector 4, Sector 5, Sector 6');
            fclose(header_fileID);
            
            csvwrite(strcat(base_path, 'ZEBRA_all_sectors_ALL_STATS.csv'), outer_cells_all_stats_ALL_N_sector_ALL_collated_w_NaN);
            header_fileID = fopen(strcat(base_path, 'ZEBRA_all_sectors_ALL_STATS_HEADER.csv'),'w');
            fprintf(header_fileID, 'my#,PA_Cell_ID,Centroid_X,Centroid_Y,Perimeter_X,Perimeter_Y,Perimeter_Index,Perimeter_order,tensor_file_1,tensor_file_2,tensor_file_3,tensor_file_4,Unused,Alpha,Sector,Gamma,Area (direct) - pixels,Area (direct)- um sq,Area (indirect) - pixels, Area (indirect)- sq um');
            fclose(header_fileID);
            
            csvwrite(strcat(base_path, 'ZEBRA_whole_heart_stats_ALL.csv'), whole_heart_stats_ALL_N);
            header_fileID = fopen(strcat(base_path, 'ZEBRA_whole_heart_stats_ALL_HEADER.csv'),'w');
            fprintf(header_fileID, 'Cardiac Axis (0-360), Corrected Area (square micrometers), Clockwise image (=1)');
            fclose(header_fileID);
            
            whole_heart_stats_ALL_N_area_mean = mean(whole_heart_stats_ALL_N(:,1));
            whole_heart_stats_ALL_N_area_std = std(whole_heart_stats_ALL_N(:,1));
            fprintf('Hearts mean area is: %f+/-%f pizels\n', whole_heart_stats_ALL_N_area_mean, whole_heart_stats_ALL_N_area_std);
           
            whole_heart_stats_ALL_N_axis_mean = circ_rad2ang(circ_mean(circ_ang2rad(whole_heart_stats_ALL_N(:,2)))); 
            %NOTE: THIS ANGLE IS NOW TREATED AS A 0-360 ANGLE BUT
            %CURRENTLY THE ABSOLUTE ANGLE ON A SCALE 0 - 360 IS REPORTED.
            fprintf('Hearts mean axis is: %f degrees.\n', whole_heart_stats_ALL_N_axis_mean);           
            zebra_circ_plot_r1(circ_ang2rad(whole_heart_stats_ALL_N(:,2)),'hist_non_axial',[],36,true,false,'linewidth',2,'color','r');
            whole_heart_axis_txt = sprintf('Mean Heart axis %3.2f\n', whole_heart_stats_ALL_N_axis_mean);

            fig = gcf;
            title_obj = title(whole_heart_axis_txt, 'Color', 'blue', 'FontSize', 18);

            fig_print_path = [base_path, 'ZEBRA_whole_heart_stats_Heart_Axis_ROSE'];
            print('-dpdf', fig_print_path);
            saveas(fig, [fig_print_path, '.png']);  
            ginput(1);
            close(fig);
     end;
end;
end

