function bound_int = zebra_boundary_intersections_fix_lines_ex_out_r1(XMAX, YMAX, C_cent, C_point, mycolor_lineB, mycolor_parallel, plot_on)
    hold on;
    instep = 1;   
    p  = polyfit([C_cent(:,1) C_point(:,1)], [C_cent(:,2) C_point(:,2)], 1);  
    slope_B = p(:,1);
    intercept_B = p(:,2);
    for n=1:XMAX;
        x2(n) = n;
        y2(n) = slope_B * n + intercept_B;
    end;
    if plot_on;
        plot(x2,y2, mycolor_lineB);
    end;
    dy2 = diff(y2);
    dx2 = diff(x2);   
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% top %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    yIntersect = 0+instep; %top
    if plot_on;
        for n=1:XMAX;
            x1(n) = n;
            y1(n) = yIntersect;
        end;
        plot(x1,y1, mycolor_parallel);
    end;
    i=find(diff(y2 > yIntersect));
    if isempty(i) == 0;
        xIntersect = x2(i)+dx2(i)*(yIntersect-y2(i))/dy2(i);
    else
        xIntersect = NaN;
    end;
    %bound_int x y
    if xIntersect > 0 + instep && xIntersect < XMAX - instep; 
        bound_int(1,1) = xIntersect;
        bound_int(1,2) = yIntersect;
    else
        bound_int(1,1) = NaN;
        bound_int(1,2) = NaN;
    end;

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% bottom %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    yIntersect = XMAX-instep; %bottom
    if plot_on;
        for n=1:XMAX;
            x1(n) = n;
            y1(n) = yIntersect;
        end;
        plot(x1,y1, mycolor_parallel);
    end;
    i=find(diff(y2 > yIntersect));
    if isempty(i) == 0;
        xIntersect = x2(i)+dx2(i)*(yIntersect-y2(i))/dy2(i);
    else
        xIntersect = NaN;
    end;
    %bound_int x y
    if xIntersect > 0 + instep && xIntersect < XMAX - instep; 
        bound_int(2,1) = xIntersect;
        bound_int(2,2) = yIntersect;
    else
        bound_int(2,1) = NaN;
        bound_int(2,2) = NaN;
    end;


    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% left %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    xIntersect = 0 + instep; %left
    if plot_on;
        for n=1:YMAX;
            x1(n) = xIntersect;
            y1(n) = n;
        end;
        plot(x1,y1, mycolor_parallel);
    end;
    i=find(diff(x2 > xIntersect));
    if isempty(i) == 0;
        yIntersect = y2(i)+dy2(i)*(xIntersect-x2(i))/dx2(i);
    else
        yIntersect = NaN;
    end;
    %bound_int x y
    if yIntersect > 0 + instep && yIntersect < YMAX -instep;
        bound_int(3,2) = yIntersect;
        bound_int(3,1) = xIntersect;
    else
        bound_int(3,2) = NaN;
        bound_int(3,1) = NaN;
    end;

    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% right %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    xIntersect = XMAX - instep; %right
    if plot_on;
        for n=1:YMAX;
            x1(n) = xIntersect;
            y1(n) = n;
        end;
        plot(x1,y1, mycolor_parallel);
    end;
    i=find(diff(x2 > xIntersect));
    if isempty(i) == 0;
        yIntersect = y2(i)+dy2(i)*(xIntersect-x2(i))/dx2(i);
    else
        yIntersect = NaN;
    end;
    %bound_int x y
    if yIntersect > 0 + instep && yIntersect < YMAX -instep;
        bound_int(4,2) = yIntersect;
        bound_int(4,1) = xIntersect;
    else
        bound_int(4,2) = NaN;
        bound_int(4,1) = NaN;
    end;
    axis([0 XMAX 0 YMAX]);
end