function [cell_original_index, next_sector] = zebra_find_closest_cell_in_this_or_next_sector_v2_r1(outercells_all_stats, S_all_sectors, curr_sector, last_cell_index, start_point)
        index_S = find(outercells_all_stats(:,15) == curr_sector);
  if(size(index_S,1) < 1)
         fprintf('WARNING, Index: %d \n', outercells_all_stats(last_cell_index,1));
         fprintf('which is \n cell_ID: %d\n' ,outercells_all_stats(last_cell_index,2));
         fprintf('is not in a segmentation sector\n Consider restarting analysis\n of this image\n');
         fprintf('(particularly if several cells are outside sectors\n');
         cell_original_index = last_cell_index;
         next_sector = curr_sector + 1;     
  else
                %process the sublists [NOT COMPUTATIONALLY EFFICIENT AS REDONE FOR
                %EACH CELL, alternative would be to pass the sub_list_cell_stats or to just use the original_cell_stats)
                sub_list_cell_stats = outercells_all_stats(index_S,:);
                %delete found cells from sublist
                index_S_remaining = 0;
                for n=1:size(sub_list_cell_stats, 1);
                    if(sub_list_cell_stats(n,8) ~= 0);
                        sub_list_cell_stats(n,3) = NaN;
                        sub_list_cell_stats(n,3) = NaN;
                    else;
                        index_S_remaining = index_S_remaining + 1;
                    end;
                end;

            if last_cell_index == 0; %first call, no cell found, so find closest cell to the specified point start_point in S1 
                index_S;
                sub_list_cell_stats = outercells_all_stats(index_S,:);
                for n = 1:size(sub_list_cell_stats,1);
                      D_curr_cc(n)  = sqrt(sum((([sub_list_cell_stats(n,3), sub_list_cell_stats(n,4)]) - start_point) .^ 2));
                end;
                min(D_curr_cc);

                curr_cell_sub_index = find(D_curr_cc <= min(D_curr_cc));
                [m,n] = size(curr_cell_sub_index);
                if(n > 1);
                    curr_cell_sub_index = curr_cell_sub_index(1);
                end;
                next_cell_centre_point = [sub_list_cell_stats(curr_cell_sub_index, 3), sub_list_cell_stats(curr_cell_sub_index, 4)];
                cell_original_index = sub_list_cell_stats(curr_cell_sub_index,1);
            else       
                %find closest remaining
                %fprintf('size(sub_list_cell_stats,1): %d\n', size(sub_list_cell_stats,1));
                for n = 1:size(sub_list_cell_stats,1);
                      D_curr_cc(n)  = sqrt(sum((([sub_list_cell_stats(n,3), sub_list_cell_stats(n,4)]) - [outercells_all_stats(last_cell_index,3), outercells_all_stats(last_cell_index,4)] ) .^ 2));
                end
                min(D_curr_cc);

                curr_cell_sub_index = find(D_curr_cc <= min(D_curr_cc));
                [m,n] = size(curr_cell_sub_index);
                if(n > 1);
                    curr_cell_sub_index = curr_cell_sub_index(1);
                end;
                next_cell_centre_point = [sub_list_cell_stats(curr_cell_sub_index, 3), sub_list_cell_stats(curr_cell_sub_index, 4)];
                cell_original_index = sub_list_cell_stats(curr_cell_sub_index,1);
            end;


            %update index
            index_S_remaining = index_S_remaining -1;
            if index_S_remaining < 1
                next_sector = curr_sector + 1;
            else
                next_sector = curr_sector;
            end;
  end;  % end, if there are cells in this sector
       
end

