function [sector_num] = zebra_whichSector_r1(C_point, S_all_sectors)
%Note: for points on the border lines precidence goes to the sectors in
%order of the list)
%     S_lc            %SECTOR 1
%     S_o             %SECTOR 2
%     S_gc_A          %SECTOR 3
%     S_gc_B          %SECTOR 4
%     S_gc_C          %SECTOR 5
%     S_av            %SECTOR 6
    
    if inpolygon(C_point(:,1), C_point(:,2), S_all_sectors(:,1,1), S_all_sectors(:,2,1)) == 1
        sector_num = 1;
    elseif inpolygon(C_point(:,1), C_point(:,2), S_all_sectors(:,1,2), S_all_sectors(:,2,2)) == 1
        sector_num = 2;
    elseif inpolygon(C_point(:,1), C_point(:,2), S_all_sectors(:,1,3), S_all_sectors(:,2,3)) == 1
        sector_num = 3;
    elseif inpolygon(C_point(:,1), C_point(:,2), S_all_sectors(:,1,4), S_all_sectors(:,2,4)) == 1
        sector_num = 4;
    elseif inpolygon(C_point(:,1), C_point(:,2), S_all_sectors(:,1,5), S_all_sectors(:,2,5)) == 1
        sector_num = 5;
    elseif inpolygon(C_point(:,1), C_point(:,2), S_all_sectors(:,1,6), S_all_sectors(:,2,6)) == 1
        sector_num = 6;
    else
        sector_num = 0;
end

